//ledmatrix7219d88 output example

#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include "ledmatrix7219d88.h"
#include "max7219.h"
#include <avr/interrupt.h>

//se folosesc PORTD2-DIN; PORTD3-CLK; PORTD4-LOAD;
/*
		|||||
	0 ........7
	8.........15
	.			.
	.			.
	.			.
	.			.
	.			.
	56.........63


*/

#define DELAY_SECVENTA		250
#define NUM_SECVENTE		6
#define D_st				1
#define D_dr				3
#define D_sus				2
#define D_jos				4
#define MAXLEN				11

int matrix_led[64];
int snakeX[MAXLEN], snakeY[MAXLEN];
int foodX, foodY;
int len = 3, dir, isfood, snakeX_tail, snakeY_tail, prev_dir;

//activez rezistentele de pull-up
void set_button() {
	DDRB &= ~((1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3));
    PORTB |= ((1 << PB0) | (1 << PB1) | (1 << PB2) | (1 << PB3));
	
	PCICR  = (1 << PCIE1);
    PCMSK1 = (1 << PCINT8) | (1 << PCINT9) | (1 << PCINT10) | (1 << PCINT11) ;
}

//initializare joc
void init(){
	int i;
	isfood = 1;
	
	for(i = 0; i < len; i++){
		snakeX[i] = 4;
		snakeY[i] = i+1;
	}
}

void sad_face() {
	ledmatrix7219d88_init();
	//while(1) {
		draw_pixel(2, 5);
		draw_pixel(3, 5);
		draw_pixel(4, 5);
		draw_pixel(5, 5);
		draw_pixel(6, 6);
		draw_pixel(7, 7);
		draw_pixel(1, 6);
		draw_pixel(0, 7);
		//eyes
		draw_pixel(1, 1);
		draw_pixel(1, 2);
		draw_pixel(2, 1);
		draw_pixel(2, 2);
		draw_pixel(5, 1);
		draw_pixel(5, 2);
		draw_pixel(6, 1);
		draw_pixel(6, 2);
		_delay_ms(60000);
	//}
}

void happy_face() {
	ledmatrix7219d88_init();
	
	//eyes
	draw_pixel(1, 1);
	draw_pixel(1, 2);
	draw_pixel(2, 1);
	draw_pixel(2, 2);
	draw_pixel(5, 1);
	draw_pixel(5, 2);
	draw_pixel(6, 1);
	draw_pixel(6, 2);
	
	//mouth
	draw_pixel(2, 6);
	draw_pixel(3, 6);
	draw_pixel(4, 6);
	draw_pixel(5, 6);
	draw_pixel(6, 5);
	draw_pixel(7, 4);
	draw_pixel(1, 5);
	draw_pixel(0, 4);
	_delay_ms(60000);
}

void erase_pixel(int x, int y) {
	ledmatrix7219d88_setledoff(*matrix_led, x*7+x+y);
	//_delay_ms(3);
}

void draw_pixel(int x, int y){
	ledmatrix7219d88_setledon(*matrix_led, x*7+x+y);
	//_delay_ms();
}

int ispartofSnake(int x, int y) {
	int i;
	
	for(i = 0; i < len; i++) {
		if ((snakeX[i] == x) && (snakeY[i] == y))
			return 1;
	}
	return 0;
}

isSnakepartofSnake() {
	int i;
	
	for(i = 1; i < len; i++) {
		if ((snakeX[0] == snakeX[i]) && (snakeY[0] == snakeY[i]))
			return 1;
	}
	return 0;
}

//generare mancare
void food_gen() { 
	foodX = rand() % 8;
	foodY = rand() % 8;
	
	while(ispartofSnake(foodX, foodY) == 1) {
		foodX = rand() % 8;
		foodY = rand() % 8;
	}
}


void draw_food() {
	food_gen();
	draw_pixel(foodX, foodY);
}

void draw_snake() {
	int i = 0;
	
	for (i = 0; i < len; i++){
		draw_pixel(snakeX[i], snakeY[i]);
		_delay_ms(70);
	}
	snakeX_tail = snakeX[len-1];
	snakeY_tail = snakeY[len-1];
	
}

ISR(PCINT1_vect) {
		if(((PINB & (1 << PB1)) == 0) && (prev_dir != D_sus)) {
			dir = D_jos;
			//draw_pixel(0,6);
		}
		if(((PINB & (1 << PB3)) == 0) && (prev_dir != D_jos)){
			dir = D_sus;
			//draw_pixel(0,4);
		}
		if(((PINB & (1 << PB0)) == 0) && (prev_dir != D_dr)){
			dir = D_st;
			//draw_pixel(6,1);
		}
		if(((PINB & (1 << PB2)) == 0) && (prev_dir != D_st)){
			dir = D_dr;
			//draw_pixel(6,2);
		}
}

//miscare sarpe
void move_snake(int direction) {
	int i;
	
	for(i = len-1; i > 0; i--){
		snakeX[i] = snakeX[i-1];
		snakeY[i] = snakeY[i-1];
	//	snakeX_tail = snakeX[len-1];
	//	snakeY_tail = snakeY[len-1];
	}
	
	//snakeX_tail = snakeX[len-1];
	//snakeY_tail = snakeY[len-1];
	bump_wall();
	
	switch(direction){
		case D_sus:
			erase_pixel(snakeX_tail, snakeY_tail);
			snakeY[0] = snakeY[0]-1;
			snakeX_tail = snakeX[len-1];
			snakeY_tail = snakeY[len-1];
			prev_dir = D_sus;
			break;
		case D_dr:
			erase_pixel(snakeX_tail, snakeY_tail);
			snakeX[0] = snakeX[0]-1;
			snakeX_tail = snakeX[len-1];
			snakeY_tail = snakeY[len-1];
			prev_dir = D_dr;
			break;
		case D_jos:
			erase_pixel(snakeX_tail, snakeY_tail);
			snakeY[0] = snakeY[0]+1;
			snakeX_tail = snakeX[len-1];
			snakeY_tail = snakeY[len-1];
			prev_dir = D_jos;
			break;
		case D_st:
			erase_pixel(snakeX_tail, snakeY_tail);
			snakeX[0] = snakeX[0]+1;
			snakeX_tail = snakeX[len-1];
			snakeY_tail = snakeY[len-1];
			prev_dir = D_st;
			break;
	}
	
	if(isSnakepartofSnake() == 1) {
		dir = 0;
	}
	
	if ((snakeX[0] == foodX) && (snakeY[0] == foodY)){
		len++;
		draw_pixel(snakeX[len-1], snakeY[len-1]);
		snakeX_tail = snakeX[len-1];
		snakeY_tail = snakeY[len-1];
		if(len < MAXLEN)
			draw_food();
		else
			isfood = 0;
	}
	
	draw_snake();
}

//ajustarea valorilor la trecerea prin perete
void bump_wall(){
	int i;
	for (i=0;i<len;i++){
		/*if (snakeX[i] < 0)
			snakeX[i] = 7;
		
		if (snakeX[i] > 7)
			snakeX[i] = 0;
		
		if (snakeY[i] < 0)
			snakeY[i] = 7;
		
		if (snakeY[i] > 7)
			snakeY[i] = 0;*/
		
		if(snakeX[i] < 0 ||snakeX[i] > 7 || snakeY[i] < 0 ||snakeY[i] > 7) {
			sad_face();
			dir = 0;
		}
			
	}
}

int main(void) {
	//init ledmatrix
	ledmatrix7219d88_init();
	set_button();
	sei();
	init();
	draw_snake();
	draw_food();
	dir = D_dr;
	prev_dir = dir;
	
	while(1) {
		move_snake(dir);
		if (dir == 0)
			sad_face();
		if(isfood == 0) {
			happy_face();
			dir = 0;
		}
		if (dir == 0)
			break;
	}
}
